// Simple 1D Cellular Automata //


#include <string.h>
#include <3ds.h>


#define WIDTH  400
#define HEIGHT 240
#define SCREEN 400*240



	int x,y,d,i;

	bool k;

	int state[WIDTH];



int main() {


	// Initialize services

	srvInit();
	aptInit();
	hidInit(NULL);
	gfxInit();

	//gfxSet3D(true); // uncomment if using stereoscopic 3D


	for (i=0;i<WIDTH;i++) state[i] = rand()%2;


	// Main loop

		while (aptMainLoop()) {


			gspWaitForVBlank();

			hidScanInput();


			u32 kDown = hidKeysDown();

			if (kDown & KEY_START) break;


			u8* fb = gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);
			
			memset(fb, 0, SCREEN * 3);


				for (y=0;y<HEIGHT;y++) {


					for (x=0;x<WIDTH;x++) {

						k = k^state[x];

						state[x] = k;

						if (k == 1)  d = 255;
						else d = 0;


						fb[3*(y+x*240)]   = d;
						fb[3*(y+x*240)+1] = d;
						fb[3*(y+x*240)+2] = d;

					}

				}

			i = 30;

			while(i--) gspWaitForVBlank();


			gfxFlushBuffers();

			gfxSwapBuffers();


		}

	// Exit services

	gfxExit();
	hidExit();
	aptExit();
	srvExit();

	return 0;

}